#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="53.000000" y="72.000000">
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="SPEED_OF_SOUND" type="float" value="343.0" description="Speed of sound (m/s)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling Rate (Hz)."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="ARG1" description="Filename of a transfer function matrix."/>
      <Parameter name="ADVANCE" type="subnet_param" value="160" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <NetOutput name="DISP" node="node_MAIN_LOOP_1" terminal="DISP" object_type="any" description="No description available"/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="327.000000" y="91.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_LocalizeMUSIC_1" type="LocalizeMUSIC" x="-119.000000" y="176.000000">
      <Parameter name="NB_CHANNELS" type="int" value="8" description="The number of input channels."/>
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame (per channel)."/>
      <Parameter name="SPEED_OF_SOUND" type="subnet_param" value="SPEED_OF_SOUND" description="Speed of sound (m/s)."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling Rate (Hz)."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="A_MATRIX" description="Filename of a transfer function matrix."/>
      <Parameter name="ELEVATION" type="float" value="0" description="An angle of elevation of source locations."/>
      <Parameter name="PERIOD" type="int" value="50" description="The number of frames used for calculating a correlation function."/>
      <Parameter name="NUM_SOURCE" type="int" value="1" description="Number of sources, which should be less than number of channels."/>
      <Parameter name="MIN_DEG" type="int" value="-180" description="source direction (lower)."/>
      <Parameter name="MAX_DEG" type="int" value="180" description="source direction (higher)."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="500" description="Lower bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="2800" description="Upper bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If the parameter is true, this node outputs sound localization results to a standard output."/>
    </Node>
    <Node name="node_SourceTracker_1" type="SourceTracker" x="16.000000" y="176.000000">
      <Parameter name="THRESH" type="float" value="24" description="Threshold of a power of Source. When the power is less than the threshold, the source is deleted."/>
      <Parameter name="PAUSE_LENGTH" type="float" value="800" description="pause length."/>
      <Parameter name="MIN_SRC_INTERVAL" type="float" value="30" description="Threshold of a source interval. When an angle between two sources are smaller than MIN_SRC_INTERVAL, the sources are given the same ID."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Output debug information if true [default: false]"/>
    </Node>
    <Node name="node_DisplayLocalization_1" type="DisplayLocalization" x="-100.000000" y="256.000000"/>
    <Node name="node_SourceIntervalExtender_1" type="SourceIntervalExtender" x="173.000000" y="176.000000">
      <Parameter name="PREROLL_LENGTH" type="int" value="0" description="The start of the source interval is extended forward by preroll length."/>
    </Node>
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="-100.000000" y="98.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="CHANNEL_COUNT" type="int" value="16" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="DEVICETYPE" type="string" value="WS" description="Device type (ASIO, ALSA, RASP, or WS)."/>
      <Parameter name="DEVICE" type="string" value="192.168.33.211" description="The name of device."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="202.000000" y="91.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 0 1 2 3 8 9 10 11 &gt;" description="Flags for channel selection. When the first three channels are selected from four channels, the flags should be set to &lt;Vector&lt;int&gt; 0 1 2&gt;."/>
    </Node>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_DisplayLocalization_1" input="SOURCES">249.5 176 381 176 381 219 -199 219 -199 256 -165 256 </Link>
    <Link from="node_SourceTracker_1" output="OUTPUT" to="node_SourceIntervalExtender_1" input="SOURCES"/>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_LocalizeMUSIC_1" input="INPUT">359.5 91 384 91 384 141 -199 141 -199 176 -170.5 176 </Link>
    <Link from="node_LocalizeMUSIC_1" output="OUTPUT" to="node_SourceTracker_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromMic_1" terminal="NOT_EOF"/>
    <NetOutput name="DISP" node="node_DisplayLocalization_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="ARG1" type="" value=""/>
  <Parameter name="160" type="" value=""/>
</Document>
