#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="285.000000" y="90.000000">
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate(Hz)"/>
      <Parameter name="TF_CONJ_FILENAME" type="subnet_param" value="ARG1" description="Filename of a transfer function matrix(for GSS system).&#10;Either &quot;TF_filename&quot; or &quot;Mic_filename&quot; is selected."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <NetOutput name="SAVE" node="node_MAIN_LOOP_1" terminal="SAVE" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="112.000000" y="-138.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_GHDSS_2" type="GHDSS" x="327.000000" y="-131.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame(per channel)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="Advance."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate(Hz)"/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="0" description="Lower bound of frequency (Hz). [default: 0]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="8000" description="Upper bound of frequency (Hz). [default: 8000]"/>
      <Parameter name="TF_CONJ" type="string" value="DATABASE" description="The TF_CONJ make method(&quot;Method value are &quot;CALC&quot; and &quot;&quot;DATABASE&quot;)."/>
      <Parameter name="TF_CONJ_FILENAME" type="subnet_param" value="TF_CONJ_FILENAME" description="Filename of a transfer function matrix(for GSS system).&#10;Either &quot;TF_filename&quot; or &quot;Mic_filename&quot; is selected."/>
      <Parameter name="MIC_FILENAME" type="string" value="MIC_FILENAME" description="Filename of mic position.&#10;Either &quot;TF_filename&quot; or &quot;Mic_filename&quot; is selected."/>
      <Parameter name="MIC_POS_SHIFT" type="string" value="FIX" description="Mic position shift.&#10;Value are &quot;SHIFT&quot; or &quot;FIX&quot; is selected."/>
      <Parameter name="FIXED_NOISE" type="bool" value="false" description="Separate fixed noise source."/>
      <Parameter name="FIXED_NOISE_FILENAME" type="string" value="" description="Filename of fixed noise position.&#10;When &quot;FIXED_NOISE = true&quot;."/>
      <Parameter name="INITW_FILENAME" type="string" value="" description="Filename of a initial separate matrix."/>
      <Parameter name="SPEED_OF_SOUND" type="float" value="343" description="Speed of sound(m/s)."/>
      <Parameter name="SS_METHOD" type="string" value="ADAPTIVE" description="The calculation method for SS step size parameter.(Method value are &quot;FIX&quot;,&quot;LC_MYU&quot;,&quot;ADAPTIVE&quot;)"/>
      <Parameter name="SS_SCAL" type="float" value="1.0" description="The SS Scaling factor."/>
      <Parameter name="SS_MYU" type="float" value="0.01" description="The SS step size parameter for GSS system.(default 0.001)"/>
      <Parameter name="NOISE_FLOOR" type="float" value="0.0" description="The noise floor value.(default 0.0)"/>
      <Parameter name="LC_CONST" type="string" value="FULL" description="The calculation method for constrain.(method value are &quot;FULL&quot;,&quot;DIAG&quot;)"/>
      <Parameter name="LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size.(method value are &quot;FIX&quot;,&quot;Adaptive&quot;)"/>
      <Parameter name="LC_MYU" type="float" value="0.01" description="The LC step size parameter.(default 0.001)"/>
      <Parameter name="UPDATE_METHOD_TF_CONJ" type="string" value="POS" description="The Update method of TF_CONJ data.(default ID)"/>
      <Parameter name="UPDATE_METHOD_W" type="string" value="ID" description="The Update method of W data.(default ID)."/>
      <Parameter name="UPDATE_ACCEPT_ANGLE" type="float" value="0.1" description="The accept angle value[deg.] for picking up from saved W value when UPDATE_METHOD is POS."/>
      <Parameter name="EXPORT_W" type="bool" value="false" description="The export result W matrix when EXPORT_W  is true."/>
      <Parameter name="EXPORT_W_FILENAME" type="string" value="gomi" description="The filename that export result W matrix when EXPORT_W  is true."/>
      <Parameter name="UPDATE" type="string" value="STEP" description="The update method.(method values are &quot;STEP&quot;,&quot;TOTAL&quot;)"/>
    </Node>
    <Node name="node_ConstantLocalization_1" type="ConstantLocalization" x="75.000000" y="-81.000000">
      <Parameter name="ANGLES" type="object" value="&lt;Vector&lt;float&gt; -60.0 60.0 &gt;" description="Angles of source locations. Each element represents an angle of each source location."/>
      <Parameter name="ELEVATIONS" type="object" value="&lt;Vector&lt;float&gt; 0.0 0.0 &gt;" description="Elevations of source locations. Each element represents an elevation of each source location."/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="78.000000" y="-7.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The length between a frame and a previous frame."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)"/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for FFT. WINDOW should be RECTANGLE, CONJ, or HAMMING."/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain which is multiplied to the output of the waveform."/>
    </Node>
    <Node name="node_SaveRawPCM_1" type="SaveRawPCM" x="220.000000" y="-7.000000">
      <Parameter name="BASENAME" type="string" value="sep_" description="Basename of saved raw PCM files."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length between adjacent frames."/>
      <Parameter name="BITS" type="int" value="16" description="Bit format of samples. 16 and 24 bits are supported."/>
    </Node>
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="46.000000" y="-226.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="CHANNEL_COUNT" type="int" value="16" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="DEVICETYPE" type="string" value="WS" description="Device type (ASIO, ALSA, RASP, or WS) [default: WS]."/>
      <Parameter name="DEVICE" type="string" value="127.0.0.1" description="Device name or IP address [default: 127.0.0.1]"/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="339.000000" y="-233.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 0 1 2 3 8 9 10 11 &gt;" description="Channel selection setting which is a vector consisting of channel IDs (ID starts with 0). When the first three channels are selected from four channels, this should be set to &lt;Vector&lt;int&gt; 0 1 2&gt;."/>
    </Node>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_GHDSS_2" input="INPUT_FRAMES"/>
    <Link from="node_ConstantLocalization_1" output="SOURCES" to="node_GHDSS_2" input="INPUT_SOURCES">145.5 -81 161 -81 161 -124 191 -123.5 </Link>
    <Link from="node_GHDSS_2" output="OUTPUT" to="node_Synthesize_1" input="INPUT">355 -131 375 -131 375 -42 -22 -42 -22 -7 40.5 -7 </Link>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_SaveRawPCM_1" input="INPUT"/>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiFFT_1" input="INPUT">395 -233 412 -233 412 -175 48 -175 48 -138 79.5 -138 </Link>
    <NetOutput name="SAVE" node="node_SaveRawPCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromMic_1" terminal="NOT_EOF"/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="ARG2" type="string" value="../config/GHDSS_Holophone.dat"/>
  <Parameter name="ARG1" type="string" value="../data/10words_Holophone.wav"/>
</Document>
